<?php
SOY2::import("module.plugins.common_item_option.logic.ItemOptionLogic");

include(dirname(__FILE__) . "/common.php");

class ItemPage extends WebPage{

	private $cart;

	function doPost(){
		if(soy2_check_token()){

			if(isset($_POST["Item"])){

				$itemDAO = SOY2DAOFactory::create("shop.SOYShop_ItemDAO");

				$items = $this->cart->getItems();

				$newItems = array();
				foreach($_POST["Item"] as $itemIndex => $value){
					if(is_array($value)){
						if( isset($value["itemDelete"]) && $value["itemDelete"] ){
							continue;
						}elseif(isset($value["itemCount"]) && is_numeric($value["itemCount"]) && $value["itemCount"] > 0){
							$count = $value["itemCount"];
						}else{
							continue;
						}

						$item = new SOYShop_Item();
						$item->setId($value["itemId"]);
						$item->setName($value["itemName"]);
						$item->setPrice($value["itemPrice"]);

						$newItems[] = $this->cart->setItemOrder($item, $count);

						//商品オプション
						//管理画面で追加
						if(strlen(trim($value["itemAttribute"]))){
							$this->cart->setAttribute("item_option_admin_{$itemIndex}_{$value["itemId"]}", $value["itemAttribute"]);//この形式が大事 CommonItemOption->getCartAttributeId("admin", $id, $itemId)
						}
						//もともと設定されているもの
						if(isset($value["attributes"])){
							foreach($value["attributes"] as $opsionId => $optionValue){
								$this->cart->setAttribute("item_option_{$opsionId}_{$itemIndex}_{$value["itemId"]}", $optionValue);//この形式が大事 CommonItemOption->getCartAttributeId($optionId, $id, $itemId)
							}
						}


					}
				}
				$this->cart->setItems($newItems);
				$this->cart->save();
			}

			if(
				isset($_POST["AddItemByName"]) && is_array($_POST["AddItemByName"])
				 && isset($_POST["AddItemByName"]["name"]) && isset($_POST["AddItemByName"]["price"]) && isset($_POST["AddItemByName"]["count"])
				 && is_array($_POST["AddItemByName"]["name"]) && is_array($_POST["AddItemByName"]["price"]) && is_array($_POST["AddItemByName"]["count"])
			){
				foreach($_POST["AddItemByName"]["name"] as $key => $value){
					$name  = isset($_POST["AddItemByName"]["name"][$key]) && strlen(isset($_POST["AddItemByName"]["name"][$key]))
					       ? trim($_POST["AddItemByName"]["name"][$key]) : "" ;
					$price = isset($_POST["AddItemByName"]["price"][$key]) && strlen($_POST["AddItemByName"]["price"][$key])
					       ? trim($_POST["AddItemByName"]["price"][$key]) : 0;
					$count = isset($_POST["AddItemByName"]["count"][$key]) && strlen($_POST["AddItemByName"]["count"][$key])
					       ? trim($_POST["AddItemByName"]["count"][$key]) : 1 ;
					if(strlen($name)>0 && strlen($price)>0 && $count > 0){
						$this->cart->addUnlistedItem($name, (int)$count, (int)$price);
						$this->cart->save();
					}
				}
			}

			if(
				isset($_POST["AddItemByCode"]) && is_array($_POST["AddItemByCode"])
				 && isset($_POST["AddItemByCode"]["code"]) && isset($_POST["AddItemByCode"]["count"])
				 && is_array($_POST["AddItemByCode"]["code"]) && is_array($_POST["AddItemByCode"]["count"])
			){
				$dao = SOY2DAOFactory::create("shop.SOYShop_ItemDAO");
				foreach($_POST["AddItemByCode"]["code"] as $key => $value){
					$code = isset($_POST["AddItemByCode"]["code"][$key]) && strlen($_POST["AddItemByCode"]["code"][$key])
					       ? trim($_POST["AddItemByCode"]["code"][$key]) : "" ;
					$count = isset($_POST["AddItemByCode"]["count"][$key]) && strlen($_POST["AddItemByCode"]["count"][$key])
					       ? trim($_POST["AddItemByCode"]["count"][$key]) : 1 ;
					if(strlen($code)>0 && $count > 0){
						try{
							$item = $dao->getByCode($code);
							$this->cart->addItem($item->getId(), $count);
							$this->cart->save();
						}catch(Exception $e){
							continue;
						}
					}
				}
			}

			if(isset($_POST["Module"]) && is_array($_POST["Module"])){
				foreach($_POST["Module"] as $moduleId => $values){
					$delete    = isset($values["delete"]) && $values["delete"];

					if($delete){
						$this->cart->removeModule($moduleId);
					}else{
						$module = $this->cart->getModule($moduleId);
						if($module){
							$name      = isset($values["name"])   ? trim($values["name"]) : "";
							$price     = isset($values["price"])  ? (int)$values["price"] : 0;
							$isInclude = isset($values["is_include"]) && ($values["is_include"]) ? 1 : 0 ;
							$isVisible = isset($values["is_visible"]) && ($values["is_visible"]) ? 1 : 0 ;

							$module->setId($moduleId);
							$module->setName($name);
							$module->setPrice($price);
							$module->setIsInclude($isInclude);
							$module->setIsVisible($isVisible);
							//$module->setType("-");//変更しない

							$this->cart->addModule($module);
						}
					}
				}
				$this->cart->save();
			}

			if(
				isset($_POST["AddModule"]) && is_array($_POST["AddModule"])
				&& isset($_POST["AddModule"]["name"]) && isset($_POST["AddModule"]["price"])
				&& is_array($_POST["AddModule"]["name"]) && is_array($_POST["AddModule"]["price"])
			){
				foreach($_POST["AddModule"]["name"] as $key => $value){
					$name = trim($_POST["AddModule"]["name"][$key]);
					$price = (int)trim($_POST["AddModule"]["price"][$key]);
					$isInclude = isset($_POST["AddModule"]["is_include"][$key]) && ($_POST["AddModule"]["is_include"][$key]) ? 1 : 0 ;
					$isVisible = isset($_POST["AddModule"]["is_visible"][$key]) && ($_POST["AddModule"]["is_visible"][$key]) ? 1 : 0 ;

					if(strlen($name) && strlen($price)){
						$module = new SOYShop_ItemModule();
						$moduleId = "admin_module." . time() . $key;
						$module->setId($moduleId);
						$module->setName($name);
						$module->setPrice($price);
						$module->setIsInclude($isInclude);
						$module->setIsVisible($isVisible);
						$module->setType($moduleId);//管理画面で登録。全く同じタイプは１つしか入らないのに注意

						$this->cart->addModule($module);
					}
				}
				$this->cart->save();
			}


			if(isset($_POST["do_save_return"])){
				SOY2PageController::jump("Order.Register");
			}else{
				SOY2PageController::jump("Order.Register.Item");
			}
		}
	}

/*
	function getOptionIndex(){
		$logic = new ItemOptionLogic();
		$list = $logic->getOptions();
		$empty = array();

		foreach($list as $index => $value){
			$empty[$index] = "";
		}

		return $empty;
	}
*/
	function __construct($args) {
		$this->cart = AdminCartLogic::getCart();
		parent::__construct();

		//パラメータから商品IDを取得
		$userId = (isset($args[0]))?$args[0]:null;
		if(isset($args[0]) && strlen($args[0])){
			$itemId = (int)$args[0];
			$this->cart->addItem($itemId, 1);
			$this->cart->save();
			SOY2PageController::jump("Order.Register");
		}

		$this->addForm("form");
		$this->buildForm();

	}

	function buildForm(){

		$itemList = $this->cart->getItems();

		$this->addModel("has_no_item_list",array(
			"visible" => !count($itemList),
		));
		$this->createAdd("item_list", "ItemList", array(
			"list" => $itemList,
			"cart" => $this->cart,
		));

		$this->createAdd("total_item_price","HTMLLabel", array(
			"text" => number_format($this->cart->getItemPrice())
		));

		$itemDAO = SOY2DAOFactory::create("shop.SOYShop_ItemDAO");
		$itemDAO->setOrder("item_code asc");
		$items = $itemDAO->get();
		$options = array();
		foreach($items as $item){
			$options[$item->getCode()] = $item->getName()." (".$item->getCode().")";
		}

		$this->addSelect("select_items",array(
				"name" => "AddItemByCode[code][]",
				"options" => $options,
				//"property" => "name",
		));


		//モジュール料金
		$modules = $this->cart->getModules();
		$this->createAdd("module_list", "_common.Order.ModuleFormListComponent", array(
			"list" => $modules,
			"hideTypes" => array("delivery_module", "payment_module"),
		));

		//総額
		$this->addLabel("total_price", array(
				"text" => number_format($this->cart->getTotalPrice())
		));

	}

    function convertDate($date){
    	return mktime(0,0,0,$date["month"],$date["day"],$date["year"]);
    }

    function convertDateText($time){
    	return date("Y",$time)."-".date("m",$time)."-".date("d",$time);
    }

}

