<?php
include(dirname(__FILE__) . "/common.php");

class PaymentPage extends WebPage{

	private $cart;


	function doPost(){
		//あえてsoy2_check_tokenなし

		$cart = $this->cart;

		//まずはエラーチェックのみ
		if(!isset($_POST["payment_module"]) || strlen($_POST["payment_module"]) < 1){
			$cart->addErrorMessage("payment","支払方法が選択されていません");
			$res = true;
		}else{
			$cart->removeErrorMessage("payment");
		}

		/* 古いのをクリア */
		$cart->removeModule($cart->getAttribute("payment_module"));
		$cart->clearAttribute("payment_module");

		//支払
		if(!$cart->hasError("payment")){
			//選択を保存
			$moduleId = @$_POST["payment_module"];
			$cart->setAttribute("payment_module",$moduleId);

			//特定のプラグインのみを読み込む：plugins/$moduleId/soyshop.payment.php
			$moduleDAO = SOY2DAOFactory::create("plugin.SOYShop_PluginConfigDAO");
			$paymentModule = $moduleDAO->getByPluginId($moduleId);
			SOYShopPlugin::load("soyshop.payment",$paymentModule);

			//実行
			SOYShopPlugin::invoke("soyshop.payment", array(
				"mode" => "select",
				"cart" => $cart
			));
		}

		$cart->save();
		if($cart->hasError()){
			SOY2PageController::jump("Order.Register.Payment");
		}else{
			SOY2PageController::jump("Order.Register");
		}

	}

    function __construct() {
		SOYShopPlugin::active("soyshop.payment");
		$this->cart = AdminCartLogic::getCart();

		parent::__construct();

		$this->addForm("form");
		$this->createAdd("payment_method_list", "Payment_methodList", array(
			"list" => $this->cart->getPaymentMethodList(),
			"selected" => $this->cart->getAttribute("payment_module")
		));

		//エラー文言
		$error = $this->cart->getErrorMessage("payment");
		$error = implode("\n", $this->cart->getErrorMessages());
		$this->addLabel("error", array(
			"html" => nl2br(htmlspecialchars($error, ENT_QUOTES, "UTF-8")),
			"visible" => isset($error) && strlen($error)
		));

    }

	function getCSS(){
		return array(
			"./css/admin/order_register.css"
		);
	}

}



/**
 * @class Payment_methodList
 * @generated by SOY2HTML
 */
class Payment_methodList extends HTMLList{

	private $selected = "daibiki";

	protected function populateItem($entity,$key,$counter,$length){
		$this->createAdd("payment_method","HTMLCheckBox", array(
			"name" => "payment_module",
			"value" => $key,
			"selected" => ( ($this->selected == $key) || ($length == 1) ),
			"label" => $entity["name"],
		));

		$this->createAdd("payment_name","HTMLLabel", array(
			"text" => $entity["name"],
		));

		$this->createAdd("payment_description","HTMLLabel", array(
			"html" => $entity["description"]
		));

		$this->createAdd("payment_charge","HTMLLabel", array(
			"text" => strlen($entity["price"]) ? number_format($entity["price"])." 円" : "",
		));
	}

	function getSelected() {
		return $this->selected;
	}
	function setSelected($selected) {
		if(strlen($selected)){
			$this->selected = $selected;
		}
	}
}
