<?php

class ModuleFormListComponent extends HTMLList {

	private $hideTypes = array();

	protected function populateItem($item) {

		$this->addInput("module_delete", array(
			"name" => "Module[" . $item->getId() . "][delete]",
			"value" => 1
		));

		$this->addInput("module_name", array(
			"name" => "Module[" . $item->getId() . "][name]",
			"value" => $item->getName()
		));

		$this->addInput("module_price", array(
				"name" => "Module[" . $item->getId() . "][price]",
				"value" => $item->getPrice()
		));

		$this->addCheckBox("is_include", array(
				"name" => "Module[" . $item->getId() . "][is_include]",
				"value" => 1,
				"selected" => $item->getIsInclude(),
				"isBoolean" => true,
				"label" => "非加算",
		));

		$this->addCheckBox("is_visible", array(
				"name" => "Module[" . $item->getId() . "][is_visible]",
				"value" => 1,
				"selected" => $item->getIsVisible(),
				"isBoolean" => true,
				"label" => "公開",
		));

		if(count($this->hideTypes) && array_key_exists($item->getType(), $this->hideTypes)){
			return false;
		}

	}

	public function setHideTypes($hideTypes){
		if(is_array($hideTypes) && count($hideTypes)){
			$this->hideTypes = array_flip($hideTypes);
		}
	}

}
?>