<?php

class ModuleListComponent extends HTMLList {

	private $hideTypes = array();

	protected function populateItem($entity) {
		$this->addLabel("module_name", array(
			"text" => $entity->getName()
		));

		$this->addLabel("module_price", array(
			"text" => ($entity->isInclude() ? "(" : "") . number_format($entity->getPrice()) . ($entity->isInclude() ? ")" : "")
		));

		if(count($this->hideTypes) && array_key_exists($entity->getType(), $this->hideTypes)){
			return false;
		}

	}

	public function setHideTypes($hideTypes){
		if(is_array($hideTypes) && count($hideTypes)){
			$this->hideTypes = array_flip($hideTypes);
		}
	}
}
?>