<?php
/**
 * @class ItemList
 * @generated by SOY2HTML
 */
class ItemList extends HTMLList{

	private $DAO;
	private $pageDAO;
	
	private $ignoreStock;

	protected function populateItem($entity){

		try{
			$item = $this->getDAO()->getById($entity->getItemId());
		}catch(Exception $e){
			$item = new SOYShop_Item();
		}

		$pageDAO = $this->getPageDAO();
		$detailPageId = $item->getDetailPageId();
		try{
			$page = $pageDAO->getById($detailPageId);
			$url = soyshop_get_page_url($page->getUri(),$item->getAlias());
		}catch(Exception $e){
			$url = null;
		}
		
		//クッキー非対応機種用
		if(defined("SOYSHOP_IS_MOBILE")&&SOYSHOP_COOKIE){
			if(defined("SOYSHOP_MOBILE_CARRIER")&&SOYSHOP_MOBILE_CARRIER== "DoCoMo"){
				$url = $url."?".session_name() . "=" . session_id();
			}
		}

		$this->createAdd("item_link","HTMLLink", array(
			"link" => $url
		));

		$this->createAdd("item_name","HTMLLink", array(
			"text" => $entity->getItemName(),
			"link" => $url
		));

		$this->createAdd("item_price", "NumberFormatLabel", array(
			"text" => $entity->getItemPrice(),
		));

		$this->createAdd("item_id","HTMLLabel", array(
			"text" => $item->getCode(),
		));
		
		$this->createAdd("item_code","HTMLLabel", array(
			"text" => $item->getCode(),
		));
		
		$this->createAdd("item_small_image","HTMLImage", array(
			"src" => $item->getAttribute("image_small")
		));
		
		$this->createAdd("item_large_image","HTMLImage", array(
			"src" => $item->getAttribute("image_large")
		));

		SOYShopPlugin::invoke("soyshop.item.customfield", array(
			"item" => $item,
			"htmlObj" => $this
		));

		$this->createAdd("order_number","HTMLInput", array(
			"name" => "ItemCount[" . $item->getId() . "]",
			"value" => $entity->getItemCount()
		));

		$this->createAdd("order_number_text", "NumberFormatLabel", array(
			"text" => $entity->getItemCount()
		));

		$this->createAdd("item_total", "NumberFormatLabel", array(
			"text" => $entity->getTotalPrice()
		));

		$this->createAdd("item_delete","HTMLLink", array(
			"link" => soyshop_get_cart_url(true) . "?a=remove&item=" . $item->getId()
		));

		$this->createAdd("item_stock_error","HTMLLabel", array(
			"visible" => ($entity->getItemCount() > $item->getOpenStock() && !$this->ignoreStock),
			"text" => "この商品は残り" . $item->getOpenStock() . "個です。"
		));

		//item++
		$this->createAdd("add_item_link","HTMLLink", array(
			"link" => soyshop_get_cart_url(true) . "?a=add&item=" . $item->getId() ."&count=1",
			"visible" => ($item->getOpenStock() > $entity->getItemCount())
		));
		
		//item--
		$this->createAdd("sub_item_link","HTMLLink", array(
			"link" => soyshop_get_cart_url(true) . "?a=add&item=" . $item->getId() ."&count=-1",
			"visible" => ($entity->getItemCount() > 1)
		));

	}

	function getDAO() {
		if(is_null($this->DAO))$this->DAO = SOY2DAOFactory::create("shop.SOYShop_ItemDAO");
		return $this->DAO;
	}
	function setDAO($DAO) {
		$this->DAO = $DAO;
	}
	function getPageDAO(){
		if(!$this->pageDAO)$this->pageDAO = SOY2DAOFactory::create("site.SOYShop_PageDAO");
		return $this->pageDAO;
	}
	
	function setIgnoreStock($ignoreStock){
		$this->ignoreStock = $ignoreStock;
	}
	function getIgnoreStock(){
		return $this->ignoreStock;
	}
	
}
?>